'''
Created on Sep 4, 2015

@author: mukuze
'''

'''
Full code for the exact factorization of boolean matrices
'''

'''imports'''
import numpy as np 
import itertools as iters
from datetime import datetime
import cPickle

'''Functions
Note: By itemsets is meant closed itemsets'''

'''global variables'''
'''Here we keep the indices of 1s in the matrix'''
indices_1s=[]

class BreakOutOfALoop(Exception): pass
    
def list_duplicates_of(seq,item):
    start_at = -1
    locs = []
    while True:
        try:
            loc = seq.index(item,start_at+1)
        except ValueError:
            break
        else:
            locs.append(loc)
            start_at = loc
    return locs
    
'''function to return key with maximum value in list'''
def f1(d):  
    v=list(d.values())
    k=list(d.keys())
    return k[v.index(max(v))]

'''Function that takes the whole input matrix file (input)
and gives as output the input matrix itself, a list of sets of the items present in each transaction,
the indices of the 1's in the input matrix, the number of columns and number or rows in input matrix'''
def input_read(path_to_file1):
    l1 = []
    with open(path_to_file1, 'r') as f:
        for line in f:
            line = line.strip()
            if len(line) > 0:
                l1.append(map(int, line.split()))
    inp=np.asanyarray(l1)
    inp=inp[1:]
    indices=np.transpose(np.nonzero(inp))
    
    # using sets to store transactions and the items they contain
    # every set contains a transaction and the itemsets present in it
    lotsosets=[set() for i in range(len(inp))]
    for i in range(len(inp)):
        for j in range(len(inp[0])):
            if inp[i,j]>0:
                lotsosets[i].add(j)
    global indices_1s
    indices_1s=indices
    return inp,lotsosets, indices, len(inp[0]), len(inp)
# calling the function above
# input_f='input_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# print trans_sets
# print indx
# print nb_cols
# print nb_rows
'''Function that takes the file of generated closed item sets (output),
the list of sets of the items present in each transaction,
and the number of columns of the input matrix
and gives as output a list of sets of the closed itemsets 
both the closed itemsets contained in the output file, the single itemsets and entire rows''' 
def closeditems_read(path_to_file2,lotsosets,nb_col):
    num_lines = sum(1 for line in open(path_to_file2))
    item_sets = [set() for i in range(num_lines)]
    cnt=0
    with open(path_to_file2, 'r') as f:
        for line in f:
            line = line.strip()
            if len(line) > 0:
                for x in map(int, line.split(",")):
                    item_sets[cnt].add(x)
                cnt+=1
    # adding each line to the set of closed itemsets
#     for x in lotsosets:
#         if x not in item_sets and len(x)!=0:
#             item_sets.append(x)
    # adding every singleton itemset to the closed itemsets
    single_items=[set() for i in range(nb_col)]
    for x in range(nb_col):
            single_items[x].add(x)
    for x in single_items:
        if x not in item_sets:
            item_sets.append(x)     
    return item_sets
# # calling the function above
# input_f='input_old.txt'
# clitems_file='output_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# print cl_items
'''Function that takes as input the list of the sets of the closed itemsets,
and the list of sets of the items present in each transaction
and gives as outputs the list of sets of the transactions which contain the closed itemsets'''
def trans_items_sets(clitems,lotsosets):
    trans_sets=[set() for z in range(len(clitems))]
   
#     for i in range (len(clitems)):
#          
#         for j in range(len(lotsosets)):
#             try:
#                 for x in clitems[i]:
#                     if x in lotsosets[j]:
#                         continue
#                     else:
#                         raise BreakOutOfALoop
#                      
#                 trans_sets[i].add(j)
#                          
#             except BreakOutOfALoop:
#                 continue
             
           
  
#     for i in range (len(clitems)):
#         for j in range(len(lotsosets)):
#             if len(clitems[i])>len(lotsosets[j]):
#                 continue
#             elif clitems[i].issubset(lotsosets[j]):
#                 trans_sets[i].add(j)
                
    # using itertools to improve speed
    incr=0
    count=0
    for i,j in iters.product(clitems,lotsosets):
        count+=1
        if i.issubset(j):
            if len(list_duplicates_of(lotsosets, j))==1:
                trans_sets[incr].add(lotsosets.index(j))
            else:
                for x in list_duplicates_of(lotsosets, j):
                    trans_sets[incr].add(x)
                    
        if count==len(lotsosets):
            incr+=1
            count=0
    
#     for i,j in iters.product(clitems,lotsosets):
#              
#         try:
#             for x in i:
#                 if x in j:
#                     continue
#                 else:
#                     raise BreakOutOfALoop
#         
#             if len(list_duplicates_of(lotsosets, j))<1:
#                 trans_sets[incr].add(lotsosets.index(j))
#             else:
#                 for x in list_duplicates_of(lotsosets, j):
#                     trans_sets[incr].add(x)
#              
#         except BreakOutOfALoop:
#             if j==lotsosets[-1]:
#                 incr+=1
#             continue
#          
#         if j==lotsosets[-1]:
#                 incr+=1
            
        
            
    
            
                
    return trans_sets

  
    
    
# calling the function above
# input_f='input_old.txt'
# clitems_file='output_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# trans_items=trans_items_sets(cl_items,trans_sets)
# print trans_items
'''Function that takes as input the list of the sets of the closed itemsets,
and the list of sets of the transactions which contain the closed itemsets
and gives as output the number of 1's that each closed itemset covers'''
def cover_number(clitems,trans_sets):
    nb1s={}
    for i in range(len(clitems)):
        nb1s[i]=len(clitems[i])*len(trans_sets[i])
    return nb1s
# # calling the function above
# input_f='input_old.txt'
# clitems_file='output_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# trans_items=trans_items_sets(cl_items,trans_sets)
# number_1s=cover_number(cl_items,trans_items)
# print number_1s 
'''Function that takes as input the list of the sets of the closed itemsets,
and the list of sets of the transactions which contain the closed itemsets
and gives as output a dictionary where keys are the indices of 1's in the input matrix
and the values are sets of closed itemsets covering that particular 1'''
def indices_cover(clitems,trans_sets):
    indx_cover={}
    for i in range(len(clitems)):
        indices_item_set=[(x,y) for x in trans_sets[i] for y in clitems[i]]
        for x in indices_item_set:
            if x in indices_1s:
                if x not in indx_cover:
                    indx_cover[x]=set()
                    indx_cover[x].add(i)
                else:
                    indx_cover[x].add(i)
    return indx_cover
# # calling the function above
# input_f='input_old.txt'
# clitems_file='output_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# trans_items=trans_items_sets(cl_items,trans_sets)
# number_1s=cover_number(cl_items,trans_items)
# indx_cover=indices_cover(cl_items,trans_items)
# print indx_cover
'''Function that takes as inputs
the transactions sets, the itemsets, the number of 1's  covered by each itemset,
the dictionary of which 1 is covered by which itemset, and the indices of 1's
and gives as ouput the factor_items list'''
def factors(trans_sets,clitems,nb1s,indx_cover,indices):
    factor_items=[]
    
#     while not len(indices)==0:
#         # get indices covered by new closed itemset
#         maxi=f1(nb1s)
#         indices_itemset=[(x,y) for x in trans_sets[maxi] for y in clitems[maxi]]
#         indices_set=set(map(tuple,indices)).difference(map(tuple,indices_itemset))
#         indices=map(list,indices_set)
#         factor_items.append(maxi) 
# 
#     # code to go with the cover mask proposed by Pauli and update the number of 1's
#     # the cover mask is the dictionary which has for keys the indices of 1s in the matrix
#     # and for values the closed itemsets which cover those 1's as sets
#         for k in indx_cover.keys():
#             if maxi in indx_cover[k]:
#                 if len(indx_cover[k].intersection(set(factor_items)))==1:
#                     for x in indx_cover[k]:
#                         nb1s[x]=nb1s[x]-1
#                         if nb1s[x]<0:
#                             nb1s[x]=0
#              
#         del nb1s[maxi]
#         testval = 0
#         fin=all(val==testval for val in nb1s.values())
#         if fin :
#             print "No closed itemset covers any 1 anymore"
#             break
    
    # new implementation
    while not len(indices)==0:
        # get indices covered by new closed itemset
        maxi=f1(nb1s)
        indices_itemset=[(x,y) for x in trans_sets[maxi] for y in clitems[maxi]]
        indices_set=set(map(tuple,indices)).difference(map(tuple,indices_itemset))
        indices=map(list,indices_set)
        factor_items.append(maxi) 
    
    # code to go with the cover mask proposed by Pauli and update the number of 1's
    # the cover mask is the dictionary which has for keys the indices of 1s in the matrix
    # and for values the closed itemsets which cover those 1's as sets
        for k in indx_cover.keys():
            if maxi in indx_cover[k]:
                if len(indx_cover[k].intersection(set(factor_items)))==1:
                    for x in indx_cover[k]:
                        nb1s[x]=nb1s[x]-1
                        if nb1s[x]<0:
                            nb1s[x]=0
             
        del nb1s[maxi]
        testval = 0
        fin=all(val==testval for val in nb1s.values())
        if fin :
#             print "No closed itemset covers any 1 anymore"
            if len(indices)==0:
#                 print "Factors ready:)"
#                 print "After some more time, Exact factorization will be done."
                break
            else:
                print "Not all 1s in the data were covered!"
    return factor_items
# # calling the function above
# input_f='input_old.txt'
# clitems_file='output_old.txt'
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# trans_items=trans_items_sets(cl_items,trans_sets)
# number_1s=cover_number(cl_items,trans_items)
# indx_cover=indx_cover(cl_items,trans_items)
# factor_items=factors(trans_items,cl_items,number_1s,indx_cover,indx)
# print factor_items
'''Function that takes as input the dictionary of which 1 is covered by which closed itemset,
and the factor_items list
and gives as output the reduced dictionary of which 1 is covered by which factor_item'''
def reduced_cover(indx_cover,factor_items):
    for k in indx_cover.keys():
        indx_cover[k] = set([elem for elem in indx_cover[k] if elem in factor_items])
    return indx_cover

'''Function that takes as input the reduced_cover
and factor_items and returns each factor_item as key and the number of covered 1's 
covered alone by this factor as value
Also deletes all factor_items which cover no 1 alone since all the ones they cover are already covered and also updates the 
scores accordingly'''
def score(reduced_cover,factor_items):
    score={}
    cnt=0
    for f in factor_items:
        for k in reduced_cover.keys():
            if len(reduced_cover[k])==1:
                for e in reduced_cover[k]:
                    if e==f:
                        cnt+=1
        score[f]=cnt
        cnt=0
    return score


'''Function that takes as input the list of the sets of the closed itemsets, 
the list of sets of the transactions which contain the closed itemsets, and 
the list of factor items
and gives as output the number of 1's that each factor item covers'''
def factor_cover_number(factor_items,clitems,trans_sets):
    factor_nb1s={}
    for i in range(len(factor_items)):                                                                          
        factor_nb1s[factor_items[i]]=len(clitems[factor_items[i]])*len(trans_sets[factor_items[i]])
    return factor_nb1s       
        
# calling the function above
# input_f='matrix_70/input_10'
# clitems_file='matrix_70/output_10'
# input_f='Dummy_data/input'
# clitems_file='Dummy_data/closed_items'
# input_f='../data/dummy/Dummy_data/input'
# clitems_file='../data/dummy/Dummy_data/closed_items'
# start_time = datetime.now()
# input_mat,trans_sets, indx, nb_cols, nb_rows=input_read(input_f)
# cl_items=closeditems_read(clitems_file,trans_sets, nb_cols)
# print 'step 1 done'
# end_time = datetime.now()
# print end_time-start_time
#     
# start_time = datetime.now()
# trans_items=trans_items_sets(cl_items,trans_sets)
# print trans_items
# # # write to disk for future use
# # with open("pickled_trans_sets.txt", "w") as fp:
# #     cPickle.dump(trans_items, fp)
#    
# # # read from disk
# # with open("pickled_trans_sets.txt", "r") as fp:
# #     x = cPickle.load(fp)
#       
# print 'step 2 done'
# end_time = datetime.now()
# print end_time-start_time
# # print trans_items
# start_time = datetime.now()
# number_1s=cover_number(cl_items,trans_items)
# print 'step 3 done'
# end_time = datetime.now()
# print end_time-start_time
#     
# start_time = datetime.now()
# indx_cover=indices_cover(cl_items,trans_items)
# print 'step 4 done'
# end_time = datetime.now()
# print end_time-start_time
#     
# start_time = datetime.now()
# factor_items=factors(trans_items,cl_items,number_1s,indx_cover,indx)
# print len(factor_items)
# print 'step 5 done'
# end_time = datetime.now()
# print end_time-start_time
#    
# start_time = datetime.now()
# reduced_indx_cover=reduced_cover(indx_cover,factor_items)
# print 'step 6 done'
# end_time = datetime.now()
# print end_time-start_time
#    
# start_time = datetime.now()
# scores,factors_=score(reduced_indx_cover,factor_items)
# print len(scores)
# print len(factors_)
# print 'step 7 done'
# end_time = datetime.now()
# print end_time-start_time
#    
# start_time = datetime.now()
# factor_nb_1s=factor_cover_number(factor_items,cl_items,trans_items)
# print 'step 8 done'
# end_time = datetime.now()
# print end_time-start_time
# # print reduced_indx_cover
# print factors_
# print scores
