'''
Created on Nov 10, 2015

@author: mukuze
'''

'''
Here we implement the algorithm to find which factor_items are neighbors in order to merge them
'''

'''imports'''
# this is the module for doing exact boolean factorization
# import Exact_bool_factorization as ebf

# other built in modules
import numpy as np
import math
import sys
import random
import time
import operator


# # data files
# input_f='input'
# clitems_file='closed_items'
# # input_f='matrix_50/input_10'
# # clitems_file='matrix_50/output_10'
# 
# try:
#     input_mat,trans_sets, indx, nb_cols, nb_rows=ebf.input_read(input_f)
#     cl_items=ebf.closeditems_read(clitems_file,trans_sets, nb_cols)
#     
#     #print cl_items
#     trans_items=ebf.trans_items_sets(cl_items,trans_sets)
#     #print trans_items
#     number_1s=ebf.cover_number(cl_items,trans_items)
#     cover=ebf.indices_cover(cl_items,trans_items)
#     factor_items=ebf.factors(trans_items,cl_items,number_1s,cover,indx)

# global variables
nb_factors=0
nb_cols=0
nb_rows=0
next_prime=0
maxrowID=0
total_nb=0
cl_items=[]
trans_items=[]
factor_items=[]
numElems=0


# we need this function to calculate the next prime number that we will use in the random hash
# functions in the MinHash algorithm
def is_prime(num):
    arg_2=int(math.floor(math.sqrt(num)))
    for j in range(2,arg_2+1):
        if (num % j) == 0:
            return False
    return True
    
# function that accepts values from the Visualization script and sets the global 
# variables to those values to be used by the functions here
def get_set_values(closed,trans, factors,number_rows,number_cols):
    global nb_factors 
    nb_factors=len(factors)
    global nb_cols
    nb_cols= number_cols
    global nb_rows
    nb_rows=number_rows
    global cl_items
    cl_items=closed
    global trans_items
    trans_items=trans
    global factor_items
    factor_items=factors
    global total_nb
    total_nb=nb_cols+nb_rows
    global maxrowID
    maxrowID = total_nb-1
    global numElems
    numElems = int(nb_factors * (nb_factors - 1) / 2)
    
    #calculate the next prime number after the highest row ID
    low=maxrowID
    high=low*10
    
    if (low % 2 == 0):
        low += 1
    for i in range(low,high,2):
        if is_prime(i):
            global next_prime
            next_prime=i
            break

# Define a function to map a 2D matrix coordinate into a 1D index.
def getTriangleIndex(i, j):
    # If i == j that's an error.
    if i == j:
        sys.stderr.write("Can't access triangle matrix with i == j")
        sys.exit(1)
    # If j < i just swap the values.
    if j < i:
        temp = i
        i = j
        j = temp
  
    # Calculate the index within the triangular array.
    # This fancy indexing scheme is taken from pg. 211 of:
    # http://infolab.stanford.edu/~ullman/mmds/ch6.pdf
    # But I adapted it for a 0-based index.
    # Note: The division by two should not truncate, it
    #       needs to be a float. 
    k = int(i * (nb_factors - (i + 1) / 2.0) + j - i) - 1
  
    return k

# function that concatenates 
# the column vector containing 1 in each position when the factor_item contains the specific row
# and the row vector containing 1 in each position where factor_item contains the specific column
# the indx argument is the index of the factor_item in the factor_items list 
def vec_gen(clitems,trans_sets,factoritem, indx,nb_cols,nb_rows):
    mylist1=list(clitems[factoritem[indx]])
    mylist2=list(trans_sets[factoritem[indx]])
    row_vec=np.zeros((1,nb_cols))
    col_vec=np.zeros((nb_rows,1))
    for i in mylist1:
        row_vec[0][i]=1
    for j in mylist2:
        col_vec[j]=1
    return np.concatenate((col_vec,row_vec.T),axis=0)
        
# Generate a list of 'k' random coefficients for the random hash functions,
# while ensuring that the same value does not appear multiple times in the 
# list.
def pickRandomCoeffs(k):
# Create a list of 'k' random values.
    randList = []
  
    while k > 0:
    # Get a random row ID.
        randIndex = random.randint(0, maxrowID) 
      
        # Ensure that each random number is unique.
        while randIndex in randList:
            randIndex = random.randint(0, maxrowID) 
        
        # Add the random number to the list.
        randList.append(randIndex)
        k = k - 1
    
    return randList

# Calculate the Jaccard Similarities between the sets represented by the factor_items
# the sets are just binary vectors resulting in the concatenation of the rows
# and columns in the data matrix with a 1 in the row or column where the factor_item
# is present

# Calculating the Jaccard similarities gets really slow for large numbers
# of documents.

def Jaccard_coef():
    # 'JSim' will store the actual Jaccard Similarity values.
    JSim = [0.0 for x in range(numElems)]
      
    if nb_factors <= 2500:
    #if True:
#         print "\nCalculating Jaccard Similarities..."
     
        # Time the calculation.
        t0 = time.time()
     
        # For every document pair...
        for i in range(0, nb_factors):
             
            # Print progress every 100 documents.
            if (i % 100) == 0:
                print "  (" + str(i) + " / " + str(nb_factors) + ")"
     
            # Retrieve the set of indices/ids for factor_item i.
            s1 = vec_gen(cl_items,trans_items,factor_items,i,nb_cols,nb_rows)
            for j in range(i + 1, nb_factors):
                # Retrieve the set of indices/ids for factor_item j.
                s2 = vec_gen(cl_items,trans_items,factor_items,j,nb_cols,nb_rows)
                # Calculate and store the actual Jaccard similarity.
                inter=np.logical_and(s1,s2)
                len_inter=np.count_nonzero(inter)
                union=np.logical_xor(s1,s2)
                len_union=np.count_nonzero(union)
                JSim[getTriangleIndex(i, j)] = float(len_inter)/ float((len_inter+len_union))   
     
        # Calculate the elapsed time (in seconds)
        elapsed = (time.time() - t0)
             
#         print "\nCalculating all Jaccard Similarities took %.2fsec" % elapsed
     
    # Delete the Jaccard Similarities, since it's a pretty big matrix. 
    return JSim   
    #del JSim

# function that returns the appropriate number of hashes
# choose 10 hash functions if the number of rows (rows+cols) is less than 100
# choose 100 if that number is more than 100, 1000 if the number is more than 1000 and so on
def numofHashes(maxrowID):
    digits = int(math.log10(maxrowID))+1
    if maxrowID<10000:
        return int(math.pow(10, (digits-1)))
    else:
        return 1000
 
# here we implement the MinHash algorithm to get the similar pairs of factor_items
# get highest row_column  Id since we concatenate the rows and columns to get the binary
# vector representing the factor_item
# the hash function will take the form
# h(x)=(ax+b)% c
# Where 'x' is the input value, 'a' and 'b' are random coefficients, and 'c' is
# a prime number just greater than maxrowID
# For each of the hash functions, generate a different coefficient 'a' and 'b'.
def minHash():
    # Time this step.
    t0 = time.time()
    # 'estJSim' will be for the estimated Jaccard Similarities found by comparing
    # the MinHash signatures.
    estJSim = [0.0 for x in range(numElems)]
    
    nb_hashfns=numofHashes(maxrowID)
    coeffA = pickRandomCoeffs(nb_hashfns)
    coeffB = pickRandomCoeffs(nb_hashfns) 
     
    # List of documents represented as signature vectors
    signatures = []
       
    # we'll just hash the IDs,
    # then take the lowest resulting hash code value. This corresponds to the index 
    # of the first ID that you would have encountered in the random order.
       
       
    # For each factor_item...
    for fact_i in range(nb_factors):
           
        # Get the concatenated rows and columns in which the factor_item is present
        rowcolIDSet = vec_gen(cl_items,trans_items,factor_items,fact_i,nb_cols,nb_rows)
        # get the indexes or IDs of only the rows and columns which are present
        # that is where the entry is 1
        rowcolID_present=np.where(rowcolIDSet==1)[0]
         
        # The resulting minhash signature for this factor_item. 
        signature = []
           
        # For each of the random hash functions...
        for i in range(0, nb_hashfns):
            # For each of the rows or columns actually in the factor_item, 
            # calculate its hash code using hash function 'i'.
             
            # Track the lowest hash ID seen. Initialize 'minHashCode' to be greater than
            # the maximum possible value output by the hash.
             
            minHashCode = next_prime + 1
             
            # For each row or column in the factor_item...
            for rowcol_indx in rowcolID_present:
                # Evaluate the hash function.
                hashCode = (coeffA[i] * rowcol_indx + coeffB[i]) % next_prime
                 
                # Track the lowest hash code seen.
                if hashCode < minHashCode:
                    minHashCode = hashCode 
                     
            # Add the smallest hash code value as component number 'i' of the signature.
            signature.append(minHashCode)
        # Store the MinHash signature for this document.
        signatures.append(signature)
     
    # Calculate the elapsed time (in seconds)
    elapsed = (time.time() - t0)  
      
#     print "\nGenerating MinHash signatures took %.2fsec" % elapsed
     
#     print '\nComparing all signatures...'  
      
    # Time this step.
    t0 = time.time()
      
    # For each of the test documents...
    for i in range(0, nb_factors):
          
        # Get the MinHash signature for document i.
        signature1 = signatures[i]
          
        # For each of the other test documents...
        for j in range(i + 1,nb_factors):
              
            # Get the MinHash signature for document j.
            signature2 = signatures[j]
              
            count = 0.0
            # Count the number of positions in the minhash signature which are equal.
            for k in range(0, nb_hashfns):
                count = count + (signature1[k] == signature2[k])
                  
            # Record the percentage of positions which matched.    
            estJSim[getTriangleIndex(i, j)] = (count / nb_hashfns)
              
    # Calculate the elapsed time (in seconds)
    elapsed = (time.time() - t0)
              
#     print "\nComparing MinHash signatures took %.2fsec" % elapsed
    return estJSim 

# function that returns pairs with similarity more than 50%

def similar_pairs(EstSimMat): 
    
    simpairs={}
    threshold = 0.5 
    
       
    # For each of the factor_item pairs...
    # save the similar pairs 
    # save the ones that appear in at least 8 random runs of the algorithm
    
    for i in range(0, nb_factors):  
        for j in range(i + 1, nb_factors):
            # Retrieve the estimated similarity value for this pair.
            estJ = EstSimMat[getTriangleIndex(i, j)]
    #             J= JSim[getTriangleIndex(i, j)]
                # If the similarity is above the threshold...
            if estJ > threshold:
                simpairs[i,j,]=0
                    
    return simpairs

# function that returns pairs with highest similarity. Here we return
# the top 2 similar pairs    
def chosen_sim_pairs(minHash):
    chosen_pairs={}
    # run the algorithm 10 times
#     print "Calculate the similarities 5 times and take the pairs whose similarity is above a 0.5 threshold as similar in descending order of similarity."
#     print "We do this 5 times to make sure the similarity is not just random cause the MinHash algorithm is random."
#     print "Loading ..."
    for i in range(1):
        pairs=similar_pairs(minHash())
        for k in pairs.keys():
            if k in chosen_pairs.keys():
                chosen_pairs[k]+=1
            else:
                chosen_pairs[k]=1
                
    return dict(sorted(chosen_pairs.iteritems(), key=operator.itemgetter(1), reverse=True)[:20])

# print chosen_sim_pairs(minHash)
# print factor_items
# print vec_gen(cl_items,trans_items,factor_items,0,nb_cols,nb_rows).T
# print vec_gen(cl_items,trans_items,factor_items,3,nb_cols,nb_rows).T
# except IOError:
#     print "File missing!"+"\n"+"Please use the Preprocessing script to generate the input, row_names, and column_names textfiles"+"\n"+"and the close_itemset_gen script to generate the closed_items textfile and run the program again"
#     sys.exit(1)
